%!TEX root=./template.tex
\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{category}[03/08/2019 Lelio Chetot]

%% Packages
	\RequirePackage{geometry}
			\setlength{\footskip}{2.25cm}
			\newgeometry{top=3cm,hmargin=2.5cm,bottom=3cm}		\savegeometry{textpages}
			\newgeometry{top=1.5cm,hmargin=1.25cm,bottom=1.75cm}\savegeometry{associations}
			\loadgeometry{textpages}
	\RequirePackage{ragged2e}
	\RequirePackage[cmyk]{xcolor} 		% convert all colors to CMYK model
	\RequirePackage[explicit]{titlesec} % for custom sections
	\RequirePackage{titletoc} 			% for custom table of content (TOC)
	\RequirePackage{tikz} 				% for graphical design
		\usetikzlibrary{calc} 			% allow coordinate computations
	\RequirePackage{background} 		% for custom background
	\RequirePackage{tcolorbox} 			% for designing some graphics elements
		\tcbuselibrary{skins}			% same
	\RequirePackage{fontspec} 			% for custom font
		\setmainfont{Arial}				% set the main font of the whole document
		\newfontfamily\TitleFont{Impact}% set a specific font for titles
	\RequirePackage{ifthen} 			% for conditionnal statements
	\RequirePackage{xargs}				% for multi-input LaTeX commands

%% Input colors
	\xdef\BotINSA@CategoryColor{brick}
	\input{botinsa-colors}

%% Customize section (numbered)
	\titleformat{name=\section}[block]{
		%
	}{
		\begin{tikzpicture}	[overlay,remember picture]
			\node[
				draw=none,
				rectangle,
				rotate=0,
				minimum width=\paperwidth,
				minimum height=\paperheight,
				anchor=center,
				fill overzoom image=\BotINSA@CategoryBackground,
			] at (current page.center)
			{};
		% 	\node[
		% 		draw=none,
		% 		rectangle,
		% 		fill=botinsa-\BotINSA@CategoryColor-faded,
		% 		opacity=.75,
		% 		rotate=-45,
		% 		minimum width=\paperwidth,
		% 		minimum height=364cm,
		% 		anchor=center
		% 	] at ($(current page.west)$)
		% 	{};
		% 	\node[
		% 		draw=none,
		% 		rectangle,
		% 		fill=botinsa-\BotINSA@CategoryColor-vivid,
		% 		rotate=-45,
		% 		opacity=.75,
		% 		minimum width=\paperwidth,
		% 		minimum height=364cm,
		% 		anchor=center
		% 	] at ($0.5*(current page.center)+0.5*(current page.north west)$)
		% 	{};
			\node[
				draw=none,
				anchor=center,
				font=\fontsize{50}{120}\TitleFont\selectfont,
				align=center,
				text width=.9\paperwidth,
				minimum width=.9\paperwidth,
				% anchor=west,
				% rotate=45,
			] at ($0.3*(current page.center)+0.7*(current page.west)+0.1*(current page.south west)$) {\vphantom{#1}};
		\end{tikzpicture}
	}{
		0pt
	}{
		%
	}[
		%
	]


%% Customize section (numberless)
	% TOC entries customization
	\titlecontents{section}[%
		0em
	]{%
		\bfseries\large\baselineskip=30pt
	}{%
		%\contentslabel{2.3em}
	}
	{%
		\hspace*{-2.3em}
	}{%
		\titlerule*[1pc]{.}\textbf{\contentspage}
	}
	\titlecontents*{subsection}[%
		0em
	]{%
		\footnotesize\baselineskip=10pt
	}{%
		%\contentslabel{2.3em}
	}
	{%
		% \hspace*{-2.3em}
	}{%
		{ }[\thecontentspage]
	}

	%Numberless section customization (TOC, Mot du RVA, etc)
	\titleformat{name=\section,numberless}[hang]{
		%
	}{
		\begin{tikzpicture}	[overlay,remember picture]
			\fill[botinsa-grey-faded] (current page.north west) rectangle (current page.south east);
			\node[
				draw=botinsa-\BotINSA@CategoryColor-vivid,
				line width=2pt,
				fill=white,
				minimum width=.8\paperwidth,
				minimum height=.8\paperheight,
			] at (current page.center) {};
			\node[
				draw=none,
				font=\fontsize{40}{40}\color{white}\TitleFont\selectfont,
				fill=botinsa-\BotINSA@CategoryColor-vivid,
				align=center,
				text width=.95\paperwidth,
				minimum width=\paperwidth,
				minimum height=.1\paperheight,
				anchor=west,
			] at ($.8*(current page.north west)+.2*(current page.west)$) {#1};
		\end{tikzpicture}
	}{
		0pt
	}{
		\vskip0.25cm%
	}[
		\Huge
	]

%% Category related commands
	% Define the color for the current category
	\newcommand\SetCategoryColor[1]{
		\xdef\BotINSA@CategoryColor{#1}
	}
	% Define the background for the current category
	\newcommand\SetCategoryBackground[1]{
		\xdef\BotINSA@CategoryBackground{#1}
	}
	% Insert a new category and its guard page if necessary
	\newcommand{\category}[3]{
		\clearpage
		\ifthenelse{\not\isodd{\value{page}}}{
			% \NoBgThispage
			\DeactivateBookmarks
			\pagecolor{botinsa-grey-faded}
			\thispagestyle{empty}%
			\null%
			\clearpage% clear the current page
		}{}
		\ActivateBookmarks
		\thispagestyle{empty}
		\SetCategoryColor{#2}
		\SetCategoryBackground{#3}
		\section{#1}
		\pagecolor{botinsa-\BotINSA@CategoryColor-faded}
		\clearpage

	}

%% Some pages related commands
	% Insert a new page dedicated to classical text content
	\newcommandx{\textpage}[2][2=default]{
		\clearpage
		\loadgeometry{textpages}
		\DeactivateBookmarks
		\SetCategoryColor{#2}
		\justify
		\section*{#1}
	}
	% Command to insert a custom TOC
	\newcommand\BotINSAtoc{
		\SetCategoryColor{brick}
		\tableofcontents
	}

%% Bookmarks related commands
	% Bookmarks template
	\newcommand{\BotINSA@Bookmark}{
		\begin{tikzpicture}[
			overlay, remember picture,
			every node/.style={
				text width=.12857\paperheight,
				minimum width=0.143\paperheight,
				minimum height=.07\paperwidth,
				align=center,
				fill=botinsa-\BotINSA@CategoryColor-vivid,
				font=\bfseries\color{white},
			}
		]
			\foreach \i/\name in
			{
				1/Animations et Loisirs,
				2/Arts et Spectacles,
				3/Cultures\\Internationales,
				4/Départements et Enseignements,
				5/Humanitaire et Dév. Durable,
				6/Sports,
				7/Sciences et Techniques
			}{
				\ifthenelse{\equal{\value{section}}{\i}}
				{
					\ifthenelse{\not\isodd{\value{page}}}
					{%then
						\node[rotate=-90,anchor=south west]
						at ($.5*(-\paperwidth,\paperheight)-{(\i-1)*0.143}*(0,\paperheight)$) {\name};
					}{
						\node[rotate=90,anchor=south east]
						at ($.5*(\paperwidth,\paperheight)-{(\i-1)*0.143}*(0,\paperheight)$) {\name};
					}
				}
			}
		\end{tikzpicture}
	}
	% Command to remove the bookmarks
	\newcommand\DeactivateBookmarks{
		\backgroundsetup{
			contents={}
		}
	}
	% Command to add the bookmarks
	\newcommand\ActivateBookmarks{
		\backgroundsetup{
			pages=all,
			scale=1,
			opacity=1,
			angle=0,
			contents={\BotINSA@Bookmark}
		}
	}

%% Global settings
	% Disable bookmarks as default
	\DeactivateBookmarks

	% Set the global page color
	\pagecolor{botinsa-grey-faded}
